{
  description = "Doggo flake";

  inputs = {
    fenix = {
      url = "github:nix-community/fenix";
      inputs.nixpkgs.follows = "nixpkgs";
    };
    nixpkgs.url = "nixpkgs/nixos-unstable";
  };

  outputs = { self, fenix, nixpkgs }:
    let pkgs = nixpkgs.legacyPackages.x86_64-linux;
    in {
      devShell.x86_64-linux = with pkgs;
        mkShell rec {
          nativeBuildInputs = [
            just
            pkg-config
            protobuf
            (fenix.packages.x86_64-linux.fromToolchainFile {
              dir = ./.;
              sha256 = "sha256-7QfkHty6hSrgNM0fspycYkRcB82eEqYa4CoAJ9qA3tU= ";
            })
            fenix.packages.x86_64-linux.rust-analyzer
          ];

          buildInputs = [
            fontconfig

            vulkan-headers
            vulkan-loader
            libGL

            libxkbcommon

            wayland
          ];

          env = {
            # WAYLAND_DISPLAY = ""; # Window has nor decoration on Wayland
            LD_LIBRARY_PATH = with pkgs; lib.makeLibraryPath buildInputs;
          };
        };

      formatter.x86_64-linux = nixpkgs.legacyPackages.x86_64-linux.nixfmt;
    };
}
